<?php
//-------------------------------------------------------------------------
// OVIDENTIA http://www.ovidentia.org
// Ovidentia is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
// See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
// USA.
//-------------------------------------------------------------------------
/**
 * @license http://opensource.org/licenses/gpl-license.php GNU General Public License (GPL)
 * @copyright Copyright (c) 2008 by CANTICO ({@link http://www.cantico.fr})
 */

require_once 'base.php';
require_once dirname(__FILE__) . '/recordset.class.php';
require_once dirname(__FILE__) . '/criteria.class.php';
require_once dirname(__FILE__) . '/exception.class.php';
require_once dirname(__FILE__) . '/customProperty.class.php';



/**
 * This is a sample class that is used to add custom
 * properties to the ORM_Field class
 *
 * This class define three custom properties
 * sCustomProp1, sCustomProp2, sNameSpace
 */
class CustomPropertiesExample extends ORM_CustomProperties
{
    /**
     * Construct the example
     */
	public function __construct()
	{
		parent::__construct();
		
		//Create three custom properties
		$this->create(
			new ORM_CustomProperty('sCustomProp1', 'Cantico'),
			new ORM_CustomProperty('sCustomProp2'),
			'sNameSpace'
		);
	}
}

//Example N.1
$oMyField1 = ORM_StringField('SchemaCollectionRef', 255, false, new CustomPropertiesExample());

$oMyField1->setCustomPropertyValue('sNameSpace', 'urn:schemas-microsoft-com:exch-data:schema-collection-ref')
	->setCustomPropertyValue('sCustomProp2', 'The custom properties are marvelous');
	
$sContent1 = $oMyField1->getCustomPropertyValue('sNameSpace');
bab_debug($sContent1);


//Example N.2
$oMyField2 = ORM_StringField('SchemaCollectionRef')
	->setCustomPropertiesObject(new CustomPropertiesExample())
	->setCustomPropertyValue('sNameSpace', 'urn:schemas-microsoft-com:exch-data:schema-collection-ref')
	->setCustomPropertyValue('sCustomProp2', 'The custom properties are marvelous');

$sContent2 = $oMyField2->getCustomPropertyValue('sNameSpace');
bab_debug($sContent2);

	
