<?php
/************************************************************************
 * OVIDENTIA http://www.ovidentia.org                                   *
 ************************************************************************
 * Copyright (c) 2003 by CANTICO ( http://www.cantico.fr )              *
 *                                                                      *
 * This file is part of Ovidentia.                                      *
 *                                                                      *
 * Ovidentia is free software; you can redistribute it and/or modify    *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2, or (at your option)  *
 * any later version.													*
 *																		*
 * This program is distributed in the hope that it will be useful, but  *
 * WITHOUT ANY WARRANTY; without even the implied warranty of			*
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.					*
 * See the  GNU General Public License for more details.				*
 *																		*
 * You should have received a copy of the GNU General Public License	*
 * along with this program; if not, write to the Free Software			*
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,*
 * USA.																	*
************************************************************************/
include_once "base.php";
require_once dirname(__FILE__).'/functions.php';

function mailspool()
{
	global $babBody;
	class temp
		{
		var $altbg = true;

		function temp()
			{
			$this->t_mail_subject = mailspooler_translate("Mail subject");
			$this->t_mail_date = mailspooler_translate("Date");
			$this->t_send = mailspooler_translate("Send");
			$this->t_delete = mailspooler_translate("Delete");
			$this->checkall = mailspooler_translate("Check all");
			$this->uncheckall = mailspooler_translate("Uncheck all");
			$this->t_waiting = mailspooler_translate("Wait for sending");

			$this->db = $GLOBALS['babDB'];
			

			$this->res = $this->db->db_query("
			SELECT 
				id,
				mail_subject, 
				UNIX_TIMESTAMP(mail_date) mail_date,
				error_msg, 
				sent_status,
			    recipients  
			FROM mailspooler_mail 
				ORDER BY mail_date DESC
				");
			$this->count = $this->db->db_num_rows($this->res);
			}

		function getnext()
			{
			if ($arr = $this->db->db_fetch_assoc($this->res)) {
				$this->id = $arr['id'];
				$this->altbg = !$this->altbg;
				$this->mail_subject = bab_toHtml($arr['mail_subject']);
				$this->mail_date = bab_toHtml(bab_longDate($arr['mail_date']));
				$this->error_msg = bab_toHtml($arr['error_msg']);
				$this->waiting = null === $arr['sent_status'];
				$this->recipients = bab_toHtml($arr['recipients']);
				return true;
			}
			return false;
		}
	}

	$temp = new temp();
	$babBody->babecho(bab_printTemplate($temp, "addons/mailspooler/mailspool.html", "list"));
}













function send_checked_mail() {

	global $babBody;
	include_once $GLOBALS['babInstallPath']."utilit/mailincl.php";
	require_once dirname(__FILE__) . '/set/mail.class.php';

	$db = $GLOBALS['babDB'];
	$mail = bab_rp('mail', false);
	if ($mail) {

		$mail_obj = bab_mail();

		if (!$mail_obj) {
			$babBody->msgerror = mailspooler_translate("Mail is not configured");
			return false;
		}

		$res = $db->db_query("
			SELECT * FROM mailspooler_mail WHERE id IN(".$db->quote($mail).")
		");
		
		$spooler = new mailspooler_mail;
		
		try {

			while ($arr = $db->db_fetch_assoc($res)) {
				$spooler->sendMail($mail_obj, $arr);
			}
		
		} catch(ErrorException $e)
		{
			$babBody->addError($e->getMessage());
		}
	}
}



function delete_checked_mail() {
	global $babDB;
	require_once dirname(__FILE__) . '/set/mail.class.php';

	$mail = bab_rp('mail', false);
	$spooler = new mailspooler_mail;
	
	if ($mail) {
	
		$res = $babDB->db_query('
			SELECT * FROM mailspooler_mail WHERE id IN('.$babDB->quote($mail).')
		');
		
		while ($arr = $babDB->db_fetch_assoc($res)) {
			$spooler->deleteEmail($arr);
		}

		
	}
}




function mailspooler_display()
{
	require_once $GLOBALS['babInstallPath'].'utilit/urlincl.php';
	global $babDB;
	$email = bab_rp('email');
	
	$res = $babDB->db_query("SELECT * FROM mailspooler_mail WHERE id =".$babDB->quote($email)."");
	$arr = $babDB->db_fetch_assoc($res);
	$mail_data = unserialize($arr['mail_data']);
	
	switch($arr['sent_status'])
	{
		case null:	$status = mailspooler_translate('Wait for sending');	break;
		case '0':	$status	= mailspooler_translate('Failed');				break;
		case '1':	$status	= mailspooler_translate('Sent');				break;
	}
	
	
	$W = bab_functionality::get('Widgets');
	/*@var $W Func_Widgets */
	
	$emailFrame = $W->Frame();
	
	$metadata = $W->TableView();
	
	$row = 0;
	
	$metadata->addItem($W->Label(mailspooler_translate('Mail subject')), $row, 0);
	$metadata->addItem($W->Label($arr['mail_subject']), $row++, 1);
	
	$metadata->addItem($W->Label(mailspooler_translate('Date')), $row, 0);
	$metadata->addItem($W->Label(bab_shortDate(bab_mktime($arr['mail_date']))), $row++, 1);
	
	if (isset($mail_data['from'])) {
		$metadata->addItem($W->Label(mailspooler_translate('From')), $row, 0);
		$metadata->addItem($W->Label(mailspooler_arrayToString(array($mail_data['from']))), $row++, 1);
	}
	
	if (!empty($mail_data['to']))
	{
		$metadata->addItem($W->Label(mailspooler_translate('To')), $row, 0);
		$metadata->addItem($W->Label(mailspooler_arrayToString($mail_data['to'])), $row++, 1);
	}
	
	if (!empty($mail_data['cc']))
	{
		$metadata->addItem($W->Label(mailspooler_translate('Cc')), $row, 0);
		$metadata->addItem($W->Label(mailspooler_arrayToString($mail_data['cc'])), $row++, 1);
	}
	
	if (!empty($mail_data['bcc']))
	{
		$metadata->addItem($W->Label(mailspooler_translate('Bcc')), $row, 0);
		$metadata->addItem($W->Label(mailspooler_arrayToString($mail_data['bcc'])), $row++, 1);
	}
	
	$metadata->addItem($W->Label(mailspooler_translate('Status')), $row, 0);
	$metadata->addItem($W->Label($status), $row++, 1);
	
	if (!empty($arr['error_msg']))
	{
		$metadata->addItem($W->Label(mailspooler_translate('Error message')), $row, 0);
		$metadata->addItem($W->Label($arr['error_msg']), $row++, 1);
	}
	
	
	$emailFrame->addItem($metadata);
	
	if ($arr['body'])
	{
		$stripTags = array('html', 'body', 'head', 'meta', 'title');
		$body = $arr['body'];
		foreach($stripTags as $tag) {
			$body = preg_replace('/<\/?' . $tag . '.*?>/is', '', $body);
		}
		$body = trim($body, " \r\n");
	} else {
		$body = bab_toHtml($arr['altbody']);
	}
	
	
	$emailFrame->addItem($W->Html($body)->addClass('widget-bordered'));
	
	if (!empty($mail_data['files']))
	{
		bab_functionality::includefile('Icons');
		$T = @bab_functionality::get('Thumbnailer');
		/*@var $T Func_Thumbnailer */
		$fileFrame = $W->Frame()->addClass(Func_Icons::ICON_LEFT_48);
		
		foreach($mail_data['files'] as $file) {
			if (is_file($file[0]))
			{
				$url = new bab_url('?tg=addon/mailspooler/mailspool');
				$url->idx = 'download';
				$url->email = $email;
				$url->file = abs(crc32($file[0]));

				
				$icon = $W->Icon($file['1'], Func_Icons::ACTIONS_DOCUMENT_DOWNLOAD);
				if ($T)
				{
					$icon->setImageUrl($T->getIcon($file[0], 48, 48)->__tostring());
				}
				
				$fileFrame->addItem($W->Link($icon, $url->toString()));
			}
		}
		
		$emailFrame->addItem($fileFrame);
	}
	
	
	if ($arr['smtp_trace']) {
		$emailFrame->addItem(
			$W->Section(mailspooler_translate('SMTP log'), $W->RichText($arr['smtp_trace']), 5)
				->setFoldable(true, true)
		);
	}
	
	$emailFrame->addClass('mailspooler-mail');
	
	$page = $W->BabPage();
	$addon = bab_getAddonInfosInstance('mailspooler');
	$page->addStyleSheet($addon->getStylePath().'main.css');
	
	$page->setTitle(mailspooler_translate('Mail'));
	$page->addItem($emailFrame);
	
	$page->displayHtml();
	
}





function mailspooler_download()
{
	global $babDB;
	
	$email = bab_rp('email');
	$file_crc = (int) bab_rp('file');
	
	$res = $babDB->db_query("SELECT * FROM mailspooler_mail WHERE id =".$babDB->quote($email)."");
	$arr = $babDB->db_fetch_assoc($res);
	$mail_data = unserialize($arr['mail_data']);
	

	
	foreach($mail_data['files'] as $file) {
		if (is_file($file[0]))
		{
			$crc = abs(crc32($file[0]));
			if ($file_crc === $crc)
			{
				bab_downloadFile(new bab_Path($file[0]), $file[1], false, true);
			}
		}
	}
}




/* main */

if( !bab_isUserAdministrator() )
{
	$babBody->addError(mailspooler_translate('Access denied'));
	return;
}

$idx = bab_rp('idx', 'list');
$item = bab_rp('item', 1); /* id site */

if (isset($_POST['send'])) {
	send_checked_mail();
}

if (isset($_POST['delete'])) {
	delete_checked_mail();
}


switch($idx) {
		
	case 'download':
		mailspooler_download();
		break;

	case 'display':
		mailspooler_display();
		$babBody->addItemMenu("list", mailspooler_translate("Mails"), $GLOBALS['babUrlScript']."?tg=addon/mailspooler/mailspool&idx=list");
		$babBody->addItemMenu("display", mailspooler_translate("Display"), $GLOBALS['babUrlScript']."?tg=addon/mailspooler/mailspool&idx=display");
		break;

	case 'list':
		mailspool();
		$babBody->setTitle(mailspooler_translate("Undelivered mails"));
		$babBody->addItemMenu("list", mailspooler_translate("Mails"), $GLOBALS['babUrlScript']."?tg=addon/mailspooler/mailspool&idx=list");
		break;
}

$babBody->setCurrentItemMenu($idx);
