<?php

require_once dirname(__FILE__) . '/../mock/MockOvidentia.php';
require_once dirname(__FILE__) . '/uploaderTest.php';

class Widget_FilePickerTest extends Widget_UploaderTest
{
    protected $itemClass = 'Widget_FilePicker';


    /**
     * The html string returned by the display() method must contain the inputWidget name.
     */
    public function testSimpleNameIsPresentInDisplayedHtml()
    {
        // Creates a Mock_Widget_Item.
        $item = $this->construct();

        $name = 'myName';
        $item->setName($name);

        $W = bab_Widgets();
        $canvas = $W->HtmlCanvas();

        $html = $item->display($canvas);

        $this->assertContains('"' . $this->getHtmlName($name) . '"', $html, 'There were no matching fullname property in the metadata for ' . $this->itemClass );
    }

    /**
     * The html string returned by the display() method must contain the inputWidget name.
     */
    public function testMultipleNameIsPresentInDisplayedHtml()
    {
        // Creates a Mock_Widget_Item.
        $item = $this->construct();

        $name = array('myContact', 'name');
        $item->setName($name);

        $W = bab_Widgets();
        $canvas = $W->HtmlCanvas();

        $html = $item->display($canvas);

        $this->assertContains('"' . $this->getHtmlName($name) . '"', $html, 'There were no matching fullname property in the metadata for ' . $this->itemClass );
    }
}
